import java.io.File;
import java.lang.reflect.Method;
import java.util.*;
import net.minecraft.client.Minecraft;

@SuppressWarnings({"rawtypes","unchecked"}) public class DimensionBase {
	public static k getWorldProvider(int i) {
		if (providerMap.containsKey(i)) {
			Class provider = providerMap.get(i);
			try {
				return (k)provider.newInstance();
			} catch (InstantiationException instantiationexception) {} catch (IllegalAccessException illegalaccessexception) {}
		} else if (i == -1) { return new aau(); }
		return new ix();
	}

	public aim getTeleporter() {
		try {
			if (teleporter != null) { return (aim)teleporter.newInstance(); }
		} catch (InstantiationException instantiationexception) {} catch (IllegalAccessException illegalaccessexception) {}
		return null;
	}

	void usePortal() {
		DimensionDIR = new File(GetSaveDir(),name);
		Minecraft minecraft = ModLoader.getMinecraftInstance();

		minecraft.f.b(minecraft.h);
		minecraft.h.K = false;

		ry world = null;
		boolean leaving = false;
		minecraft.h.bK = minecraft.h.bK == number ? 0 : number;
		if (minecraft.h.bK == number) {
			leaving = true;
		}
		minecraft.h.c(minecraft.h.s,minecraft.h.t,minecraft.h.u,minecraft.h.y,minecraft.h.z);
		minecraft.f.a(minecraft.h,false);
		world = new ry(minecraft.f,getWorldProvider(minecraft.h.bK));
		if (minecraft.h.bK == 0 || minecraft.h.bK == -1) {
			minecraft.a(world,ChangeMessage(!leaving,name),minecraft.h);
		} else {
			changeWorld(world,ChangeMessage(!leaving,name),minecraft.h);
		}
		minecraft.h.o = minecraft.f;
		minecraft.f.a(minecraft.h,false);
		aim teleporter = getTeleporter();
		if (teleporter == null) {
			teleporter = new aim();
		}
		teleporter.a(minecraft.f,minecraft.h);
	}

	public static void usePortal(int dim) {
		System.out.println(dim);
		DimensionBase dimension = dimMap.get(dim);
		if (dimension == null) {
			System.out.println("Why");
		}
		dimension.usePortal();
	}

	private static String ChangeMessage(boolean b, String name) {
		return b ? "Leaving the " + name : "Entering the " + name;
	}

	public static void respawn(boolean flag, int i) {
		Minecraft minecraft = ModLoader.getMinecraftInstance();
		if (!minecraft.f.I && !minecraft.f.y.d()) {
			usePortal(i);
		}
		minecraft.a(flag,i,false);
		try {
			Method method = (net.minecraft.client.Minecraft.class).getDeclaredMethod("d",new Class[]{java.lang.String.class});
			method.setAccessible(true);
			method.invoke(minecraft,new Object[]{"Respawning"});
		} catch (Exception exception) {
			exception.printStackTrace();
		}
		if (minecraft.s instanceof j) {
			minecraft.a((xe)null);
		}
	}

	public void changeWorld(ry world, String s, vi entityplayer) {
		Minecraft minecraft = ModLoader.getMinecraftInstance();
		d ichunkloader = new tn(DimensionDIR);
		world.A = new jz(world,ichunkloader,world.y.c());
		minecraft.a(world,s,entityplayer);

	}

	private static File GetSaveDir() {
		Minecraft minecraft = ModLoader.getMinecraftInstance();
		if (minecraft.f != null) {
			e savehander = (e)minecraft.f.B;
			return savehander.a();
		} else return null;
	}

	public DimensionBase(int DimNumber, Class worldprovider, Class Teleporter) {
		number = DimNumber;
		worldProvider = worldprovider;
		teleporter = Teleporter;
		providerMap.put(number,worldProvider);
		dimMap.put(DimNumber,this);
	}

	public static HashMap<Integer,Class> providerMap = new HashMap(5,0.75F);
	public static HashMap<Integer,DimensionBase> dimMap = new HashMap(5,0.75F);
	public Class worldProvider;
	public Class teleporter;
	public String name;
	public int number;
	public File DimensionDIR;
	public String soundTrigger;
	public String soundTravel;
	public static ry normalWorld;
}